accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from accounts.views import signup

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path
from projects.views import (
    ProjectDeleteView,
    ProjectListView,
    ProjectDetailView,
    ProjectCreateView,
    ProjectUpdateView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
    path(
        "<int:pk>/delete", ProjectDeleteView.as_view(), name="delete_project"
    ),
    path("<int:pk>/edit", ProjectUpdateView.as_view(), name="edit_project"),
]

tasks/urls.py
from django.urls import path
from tasks.views import TaskCreateView, TaskListView, TaskUpdateView

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView


urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
]

accounts/models.py
# from django.db import models

# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings


# Create your models here.
USER_MODEL = settings.AUTH_USER_MODEL


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models

from projects.models import USER_MODEL

# Create your models here.


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        USER_MODEL, null=True, related_name="tasks", on_delete=models.SET_NULL
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login

# Create your views here.


def signup(request):
    form = UserCreationForm
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(
                username=username, password=password
            )
            user.save()
            login(request, user)
            return redirect("home")
    context = {
        "form": form,
    }
    return render(request, "registration/signup.html", context)

projects/views.py
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy

from projects.models import Project

# Create your views here.


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class ProjectDeleteView(LoginRequiredMixin, DeleteView):
    model = Project
    template_name = "projects/delete.html"
    success_url = reverse_lazy("list_projects")


class ProjectUpdateView(LoginRequiredMixin, UpdateView):
    model = Project
    template_name = "projects/delete.html"
    fields = ["name", "description", "members"]
    success_url = reverse_lazy("list_projects")

tasks/views.py
from django.views.generic.edit import CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy

from tasks.models import Task

# Create your views here.


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["is_completed"]

    def get_success_url(self):
        return reverse_lazy("show_my_tasks")

projects/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta name="description" content="Hackreactor"/>
        <meta name="keywords" content="HTML, Django, Python"/>
        <meta charset="UTF-8"/>
        <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
        <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link rel="stylesheet" href="{% static 'css/app.css' %}">
        <title>Tracker</title>
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Sign Up</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            {% block content %}
            {% endblock content %}
        </main>
    </body>
</html>

projects/templates/projects/delete.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div class="createproject">
            <form method="post">
                {% csrf_token %}
                <p>Are you sure you want to delete "{{ recipe }}"?</p>
                {{ form.as_p }}
                <div>
                    <button class="button">Delete</button>
                </div>
            </form>
        </div>
    </main>
{% endblock content %}

projects/templates/projects/detail.html
{% extends "base.html" %}
{% block content %}
    <div class= "container">
        <div class="smallcontainer">
            <h1 id="detailheader">{{ project.name }}</h1>
            {% load markdownify %}
            {{ project.description|markdownify }}
            {% if project.tasks.all %}
            </div>
            <table class="table">
                <thead>
                    <tr>
                        <td>
                            <div>
                                <span>Name</span>
                                <span>Assignee</span>
                                <span>Start date</span>
                                <span>Due date</span>
                                <span>Is completed</span>
                            </div>
                        </td>
                    </tr>
                </thead>
                <tbody>
                    {% for task in project.tasks.all %}
                        <tr>
                            <td >
                                <div>
                                    <span>{{ task.name }}</span>
                                    <span>{{ task.assignee }}</span>
                                    <span>{{ task.start_date|date:"M d" }}</span>
                                    <span>{{ task.due_date|date:"M d" }}</span>
                                    <span>{{ task.is_completed|yesno }}</span>
                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        {% else %}
            <p>This project has no tasks</p>
        {% endif %}
        <div class= "specialbutton">
            <p>
                <a class="createbutton" href="{% url 'create_task' %}">Create a new task</a>
            </p>
        </div>
    </div>
{% endblock content %}

projects/templates/projects/edit.html
{% extends 'base.html' %}
{% block content %}
    <main class="createproject">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Update</button>
            </div>
        </form>
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends "base.html" %}
{% block content %}
    <div class= "container">
        <h1>My Projects</h1>
        {% if not project_list %}
            <p>You are not assigned to any projects</p>
        {% else %}
            <table class= "table">
                <tbody>
                    {% for project in project_list %}
                        <tr>
                            <td >
                                <div>
                                    <span>
                                        <a href="{% url 'show_project' project.pk %}">{{ project.name }}
                                        </span>
                                        <span><a class= "button" href="{% url 'edit_project' project.id %}">Update</a></span>
                                        <span><a class= "button" href="{% url 'delete_project' project.id %}">Delete</a></span>
                                    </div>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% endif %}
                <p>
                    <a class= "createbutton" href="{% url 'create_project' %}">Create a new project</a>
                </p>
            </div>
        {% endblock content %}

projects/templates/projects/new.html
{% extends "base.html" %}
{% block content %}
    <div class= "createproject">
        <h1>Create a new project</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </div>
{% endblock content %}

projects/templates/tasks/list.html
{% extends "base.html" %}
{% block content %}
    <div class= "container">
        <h1>My Tasks</h1>
        {% if not task_list %}
            <p>You have no tasks</p>
        {% else %}
            <table class= "table">
                <thead>
                    <tr>
                        <td>
                            <div>
                                <span>Name</span>
                                <span>Start date</span>
                                <span>End date</span>
                                <span>Is completed</span>
                            </div>
                        </td>
                    </tr>
                </thead>
                <tbody>
                    {% for task in task_list %}
                        <tr>
                            <td >
                                <div>
                                    <span>{{ task.name }}</span>
                                    <span>{{ task.start_date|date:"M d" }}</span>
                                    <span>{{ task.due_date|date:"M d" }}</span>
                                    <span>
                                        {% if not task.is_completed %}
                                            <form method="post" action="{% url 'complete_task' task.id %}">
                                                {% csrf_token %}
                                                <input type="hidden" name="is_completed" value="True">
                                                <button class="button">Complete</button>
                                            </form>
                                        {% else %}
                                            {{ task.is_completed|yesno:"Done, " }}
                                        {% endif %}
                                    </span>
                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        {% endif %}
        <p>
            <a class= "createbutton" href="{% url 'create_task' %}">Create a new task</a>
        </p>
    </div>
{% endblock content %}

projects/templates/tasks/new.html
{% extends "base.html" %}
{% block content %}
    <div class="createproject">
        <h1>Create a new task</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </div>
{% endblock content %}